/*
 * @Author: your name
 * @Date: 2021-09-14 16:44:53
 * @LastEditTime: 2021-12-14 10:09:41
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: /NOP_EHR/media/igs/xnm/☆☆项目建档(禁删)☆☆/rm_task/module/task/task.h
 */

/**
 * @file
 **/

#pragma once

#include <memory>
#include <string>

 

#include "status.h"
#include "dependency_injector.h"
#include "frame.h"
#include "lane_info.h"
#include "observer.h"

namespace rm {

class Task {
 public:
  explicit Task(const std::shared_ptr<Observer>& observer);

  Task(const std::shared_ptr<Observer>& observer,const std::shared_ptr<DependencyInjector>& injector);

  virtual ~Task() = default;

  const std::string& Name() const;

  // const TaskConfig& Config() const { return config_; }

  virtual common::Status Execute(Frame* frame, LaneInfo* lane_info);

protected:
  Frame* frame_ = nullptr;

  LaneInfo* lane_info_ = nullptr;

  // TaskConfig config_; 
  std::shared_ptr<Observer> observer_;

  std::string name_;

  std::shared_ptr<DependencyInjector> injector_;
};

}  // namespace rm
